do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_JADEFIREMASTERS_Mobile_FakeMonkBoss=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Mobile_FakeMonkBoss
	
	function class:GetName()
		--override, don't call super
		return "Jadefire FakeMonkBoss (mobile) "..tostring(self.id)
	end

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)	
	local DISTANCE=yard*8.75	--TODO: this number shows up in two different places, consolidate
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		self.state=0
		self.hitdetect=true
		self.alivetime=0
		self.targetdist=DISTANCE
		self.flashclass=nil	--TBD after clonecounter is set
		--set by groupdancemodule:
		self.clonecounter=0	
		self.targetx=0
		self.targety=0
		self.angleindex=0
		self.visible=false
		self.targetplayer=nil
		self.groupdancemodule=nil
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MonkBoss_Orc.new()
		self.drawable:Setup(self,self.environment)
	end
	
	-- call after setting clonecounter
	function class:SetGhostAura()
		local auraclass
		if(self.clonecounter==1 or self.clonecounter==5)then
			auraclass=TRAININGGROUNDS_JADEFIREMASTERS_Aura_BlueGhost
		elseif(self.clonecounter==2 or self.clonecounter==4)then
			auraclass=TRAININGGROUNDS_JADEFIREMASTERS_Aura_GreenGhost
		else
			auraclass=TRAININGGROUNDS_JADEFIREMASTERS_Aura_RedGhost
		end
		self.combat:ApplyAuraByClass(auraclass,self.combat)
	end

	function class:Step(elapsed)	
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		
		local angle=(math.pi*2/6)*(self.angleindex)
		

		
		-- local VISIBLE_TIME=0.500
		-- local FLASH_TIME=VISIBLE_TIME+0.300
		-- local START_ANIM_TIME=FLASH_TIME+1.375		
		-- local START_HOLD_TIME=START_ANIM_TIME+0.5
		-- local START_CHARGE_TIME=START_HOLD_TIME+0.25
		-- local END_CHARGE_TIME=START_CHARGE_TIME+0.125

		local VISIBLE_TIME=0.500
		local FLASH_TIME=VISIBLE_TIME+0.000
		local START_ANIM_TIME=FLASH_TIME+.875		
		local START_HOLD_TIME=START_ANIM_TIME+0.5
		local START_CHARGE_TIME=START_HOLD_TIME+0.25
		local END_CHARGE_TIME=START_CHARGE_TIME+0.125
		
		
		if(self.state==0)then
			self.state=self.state+1			
			self.drawable.animationsystem:SetAnimation(TRAININGGROUNDS_JADEFIREMASTERS_ANIMATION_LIST.MultiSidedStrike_KneelLoop)					
		elseif(self.state==1 and self.alivetime>VISIBLE_TIME)then
			self.state=self.state+1			
			self.visible=true
		elseif(self.state==2 and self.alivetime>FLASH_TIME)then
			self.state=self.state+1			
			local flash=TRAININGGROUNDS_JADEFIREMASTERS_Decor_FlashTest.new()
			flash.clonecounter=self.clonecounter	-- set this before calling setup!
			flash:Setup(self.environment)
			flash.x=self.x
			flash.y=self.y
			flash.z=1*yard
		elseif(self.state==3 and self.alivetime>START_ANIM_TIME)then
			self.state=self.state+1			
			self.drawable.animationsystem:SetAnimation(TRAININGGROUNDS_JADEFIREMASTERS_ANIMATION_LIST.MultiSidedStrike_Start)			
			if(self.targetplayer~=self.groupdancemodule.raid.players[1])then
				--NOTE: why is this angle, and not angle+math.pi ??
					-- because "angle" is pointing from the middle outward
				self.targetplayer.projectedmovementfacing=angle
				self.targetplayer.currentfacing_3D=self.targetplayer.projectedmovementfacing
				--self.targetplayer.currentfacing=self.targetplayer.projectedmovementfacing
				self.targetplayer.targetfacing_3D=self.targetplayer.projectedmovementfacing
			end			
		elseif(self.state==4 and self.alivetime>START_HOLD_TIME)then
			self.state=self.state+1			
		elseif(self.state==5 and self.alivetime>START_CHARGE_TIME)then
			self.state=self.state+1
			self.drawable.animationsystem:SetAnimation(TRAININGGROUNDS_JADEFIREMASTERS_ANIMATION_LIST.MultiSidedStrike_Loop)

		end
		-- no "elseif" here, fall through to next case
		if(self.state==6)then
			local dist=1-(self.alivetime-START_CHARGE_TIME)/(END_CHARGE_TIME-START_CHARGE_TIME)
			if(dist>1.0)then dist=1.0 end
			local END_DIST=-0.45
			if(dist<END_DIST)then dist=END_DIST; self.state=self.state+1 end
			self.targetdist=dist*DISTANCE
		end
		if(self.state==7)then			
			local ghostalpha=0.5	--TODO: consolidate
			local fadetime=0.5
			local targetalpha=ghostalpha*(((END_CHARGE_TIME+fadetime)-self.alivetime)/(fadetime))				
			local visual_modelalpha=self.combat.auramodule.visual_modelalpha
			if(#visual_modelalpha>0)then
				local aura=visual_modelalpha[1]
				aura.alpha=targetalpha
			end				
			if(targetalpha<=0)then
				self:Die()
			end			
	
		end
		
		self.x=self.targetx+math.cos(angle)*self.targetdist;self.y=self.targety+math.sin(angle)*self.targetdist		
		
		if(self.hitdetect and self.targetdist<0.25)then
			self.hitdetect=false
			self.targetplayer.drawable:SetAnimation(TRAININGGROUNDS_JADEFIREMASTERS_ANIMATION_LIST.MultiSidedStrike_Impact)
			local playerangle=self.targetplayer.currentfacing_3D
			--face TOWARDS the strike == opposite direction of the strike angle (so add math.pi)
			--playerangle=playerangle+math.pi	
			--local leeway=((math.pi*2)/6) * (1/7)	-- there is NOT much leeway on this!
			local leeway=((math.pi*2)/6) * (1/6)	-- 1/7 is based on that one strategy video.  we're making it slightly easier to account for reduced mouse responsiveness
			local difference=angle-playerangle
			difference=TRAININGGROUNDS_Atan2Modulo(difference)			
			difference=math.abs(difference)
			--local invertdifference=math.pi-math.abs(difference)
			--invertdifference=TRAININGGROUNDS_Atan2Modulo(invertdifference)
			--print("Invertdiff:",invertdifference, invertdifference/leeway)
			if(difference<=leeway)then			
				self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_JADEFIREMASTERS_CustomDanceEventType.SUCCESS,
									source=self.targetplayer.combat})
			else
				self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_JADEFIREMASTERS_CustomDanceEventType.MISS,
									source=self.targetplayer.combat})

			end
		end
		
		
	end
end