local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_Aura
	TRAININGGROUNDS_JAINA_Aura_FrozenSeas=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Aura_FrozenSeas
	
	-- Frozen Seas does nothing by itself; other auras check whether it exists
	-- to determine if the player should be snared or frozen.
	-- (it only exists while the dance is in progress)
end

do
	local super=TRAININGGROUNDS_Aura_Snare
	TRAININGGROUNDS_JAINA_Aura_ChillingTouch=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Aura_ChillingTouch

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.percent=1.0
		self.intensity=0
		self.basetickrate=1.0
		self.tickdelay=self.basetickrate
		self.usepartialticks=false
		self.tickcounter=0	-- every 10 ticks, increase intensity by 1
		self.freezetickcounter=0	--at 20 stacks, 1-4 second delay before freezing
		self.maxfreezeticks=self:CalcNewFreezeTicks()
		-- groupdancemodule must be set or ticks will be ignored (snare should still work)
		self.groupdancemodule=nil
	end
	
	function class:CalcNewFreezeTicks()
		return 1+math.floor(math.random()*4)	-- at 20 intensity, wait between 1 and 4 ticks before freezing to simulate >80% health
	end
	
	
	function class:GetPercent()
		local PER_INTENSITY=0.02
		return self.percent-self.intensity*PER_INTENSITY
	end	
	
	function class:OnTick(ticktime,percentage)
		super.OnTick(self,ticktime,percentage)
		self.tickcounter=self.tickcounter+1		
		if(self.intensity<20)then
			--TODO: check if player is in ice patch, immediately add 1 intensity per tick if so
			if(self.tickcounter>=10)then
				self.tickcounter=self.tickcounter-10
				self.intensity=self.intensity+1
			end
		else			
			self.freezetickcounter=self.freezetickcounter+1
			if(self.freezetickcounter>=self.maxfreezeticks)then
				-- local fs=self.targetcombat:ApplyAuraByClass(TRAININGGROUNDS_JAINA_Aura_FrozenSolid,self.targetcombat)
				-- fs.groupdancemodule=self.groupdancemodule
				-- self:Die()
				if(self.groupdancemodule and self.groupdancemodule.ApplyFrozenSolid)then
					self.groupdancemodule:ApplyFrozenSolid()
				else
					--TODO: figure out why we can sometimes end up here...
				end
			end
		end
	end	
end


do
	local super=TRAININGGROUNDS_Sprite
	TRAININGGROUNDS_JAINA_Sprite_ChillingTouch=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Sprite_ChillingTouch
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		-- must set groupdancemodule after calling setup
		self.groupdancemodule=nil
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite.new()		
		self.drawable:Setup(self,self.environment)
		self.drawable.ystretch=false
		self.drawable.width=100
		self.drawable.height=100	
		self.drawable.frame.texture:Show()
		self.drawable.frame.texture:SetTexture("interface\\icons\\ability_mage_frostjaw.blp")
		self.drawable.frame.fontstring:Show()
		self.drawable.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",48,"OUTLINE")
		self.drawable.frame.fontstring:SetText("")
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraph
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		local intensity=""
		if(self.groupdancemodule and self.groupdancemodule.player)then
			local player=self.groupdancemodule.player
			local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_ChillingTouch)
			self.drawable.frame.texture:SetTexture("interface\\icons\\ability_mage_frostjaw.blp")
			if(#auras>0)then			
				local aura=auras[1]
				intensity=tostring(aura.intensity)				
			else
				local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSolid)
				if(#auras>0)then
					self.drawable.frame.texture:SetTexture("interface\\icons\\spell_frost_ring of frost.blp")
				end
			end
		end
		self.drawable.frame.fontstring:SetText(intensity)
	end
end



do
	local super=TRAININGGROUNDS_Aura_Snare
	TRAININGGROUNDS_JAINA_Aura_FrozenSolid=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Aura_FrozenSolid

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.percent=0
		--self.basetickrate=8.0
		--self.tickdelay=self.basetickrate
		self.usepartialticks=false
		self.tickcounter=0	-- every 10 ticks, increase intensity by 1		
		-- groupdancemodule must be set or ticks will be ignored (snare should still work)
		self.groupdancemodule=nil
	end

	-- function class:OnTick(ticktime,percentage)
		-- super.OnTick(self,ticktime,percentage)	
		-- self:Die()		
	-- end	
	
	--TODO: should be OnRemove, but nothing calls OnRemove yet
	function class:OnExpiry()
		super.OnExpiry(self)
		if(self.groupdancemodule)then
			local player=self.groupdancemodule.player
			local aura=player.combat:ApplyAuraByClass(TRAININGGROUNDS_JAINA_Aura_ChillingTouch,player.combat)
			aura.intensity=1
			aura.groupdancemodule=self
		end
	end
	
end




do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Decor_IceBlock=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Decor_IceBlock
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=true
		-- set by groupdancemodule after setup
		self.endtime=0
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_IceBlock.new()		
		self.drawable:Setup(self,self.environment)
	end
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.state==1 and self.alivetime>1)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)
		elseif(self.state==2 and self.alivetime>=self.endtime)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		elseif(self.state==3 and self.alivetime>=self.endtime+0.5)then			
			self:Die()		
		end
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_IceBlock=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_IceBlock
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		-- Frozen Orb projectile
		self.modelfilename="spells/8fx_jaina_icetomb_state.m2"		
		self.scale3D=0.25	--TODO: probably move to modelinfo
		self.positionmultiplier=0.45/self.scale3D	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		--self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		self.defaultanimation=0	
		self.camera2Dlocation={0,60,60*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-1.5}			
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=500
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Decor_ShatteringLance=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Decor_ShatteringLance
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		--self.ysortable=true
		self.endtime=9.0+1.0
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_ShatteringLance.new()		
		self.drawable:Setup(self,self.environment)
	end
	function class:Step(elapsed)
		super.Step(self,elapsed)
			--TODO: why MUST we add math.pi here?  changing camera angle doesn't work
		self.drawable.frame:SetFacing(self.currentfacing+math.pi)
		self.alivetime=self.alivetime+elapsed
		if(self.state==1 and self.alivetime>1)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)
		elseif(self.state==2 and self.alivetime>=self.endtime)then
			self.state=self.state+1
			local SPEED=yard*200
			self.xspeed=SPEED*math.cos(self.currentfacing)
			self.yspeed=SPEED*math.sin(self.currentfacing)
			local cone=TRAININGGROUNDS_Telegraph_Cone_FlashOnce.new()
			local sweepangle=(math.pi*2.0*0.001)
			local radius=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(200)	--TODO: fix magic number		
			local x1=self.x
			local y1=self.y		
			cone:Setup(self.environment)
			cone:PositionCone(x1,y1,self.currentfacing,sweepangle,radius)
			cone:SetColor(1,0,0,1)
			--hit detection
			if(self.groupdancemodule)then
				local PLAYERRADIUS=yard*1.5
				local player=self.groupdancemodule.player
				local x2=x1+math.cos(self.currentfacing)*yard*200
				local y2=y1+math.sin(self.currentfacing)*yard*200
				if(TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,player.x,player.y,PLAYERRADIUS))then
					self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_SHATTERINGLANCE,
					source=self.groupdancemodule.player.combat})
					self.groupdancemodule:ApplyChillingTouchStacks(3,true)
					--knockback, but only if player isn't frozen
					local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSolid)
					if(#auras==0)then					
						player.zspeed=yard*11.7
						if(player.z<1)then player.z=1 end
						player.xspeed=math.cos(self.currentfacing)*yard*20
						player.yspeed=math.sin(self.currentfacing)*yard*20
					end
				end
			end
			
		elseif(self.state==3 and self.alivetime>=self.endtime+0.5)then			
			self:Die()		
		end
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_ShatteringLance=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_ShatteringLance
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		-- Frozen Orb projectile
		self.modelfilename="spells/8fx_jaina_shatteringlance_missile.m2"
		self.scale3D=0.25	--TODO: probably move to modelinfo
		self.positionmultiplier=0.45/self.scale3D	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		--self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		self.defaultanimation=0	
		self.camera2Dlocation={-3,60,60*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={-3,0,-.5}		
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=200
	end	
	function class:SetFrameLayer()
		--self.framelayer=self.owner.environment.cameramanager.ysortframelayer
		self.framelayer=self.owner.environment.cameramanager.nameplateframelayer
	end
end



-- Timewarp-related effects
do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Decor_TimeWarp=TRAININGGROUNDS_inheritsFrom(super)		
	local class=TRAININGGROUNDS_JAINA_Decor_TimeWarp	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.expirytime=self.environment.localtime+1.5
		self.ysortable=true
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_TimeWarp.new()		
		self.drawable:Setup(self,self.environment)
	end
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.x=self.owner.x
		self.y=self.owner.y-1
		self.z=self.owner.z+yard*4
	end
	
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_TimeWarp=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_TimeWarp
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		--self.modelfilename="spells/mage_timewarp_impact_head.m2"
		self.modelfilename="spells/mage_timewarp_impact_01.m2"
		self.camera2Dlocation={0,20,20*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-.5}	
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=300
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end	
	--------------------------------------------------------------------------------
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Decor_JainaIceBlock=TRAININGGROUNDS_inheritsFrom(super)		
	local class=TRAININGGROUNDS_JAINA_Decor_JainaIceBlock
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.expirytime=self.environment.localtime+20.0
		self.ysortable=true
		self.state=1
		self.alivetime=0
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_JainaIceBlock.new()		
		self.drawable:Setup(self,self.environment)
	end
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.state==1 and self.alivetime>0.75)then	
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)
		elseif(self.state==2 and self.alivetime>19.25)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		end
	end

	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_JainaIceBlock=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_JainaIceBlock
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_lordaeronscenario_iceblock_basestatelow.m2"
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-1.5}	
		self.camera2Dtarget={0,0,-1}	
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=500
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end	
	
	
end