local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_JAINA_Spell_Broadside=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Spell_Broadside
	function class:GetName()
		return "Broadside"
	end		
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.basecastduration=1.0
		self.range=nil
		self.basegcd=1.0	
		self.blockqueueingwhilecasting=true
	end
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end
	function class:NewCast()
		local spellinstance=super.NewCast(self)
		spellinstance.groupdancemodule=self.groupdancemodule
		return spellinstance
	end	
	function class:StartCasting(caststarttime)		
		local caster=self.castercombat.owner
		super.StartCasting(self,caststarttime)
		self:ApplyGCD(caststarttime)		
	end		
	function class:CompleteCastingEffect(castendtime)
		--50% chance player is one of the three targeted with Broadside
		local r=math.floor(math.random()*3)+1		
		--50% chance player isn't targeted and we create a 3rd NPC instead
		if(math.random()>0.5)then r=4 end		
		for i=1,3 do
			local player
			if(i==r)then
				player=self.groupdancemodule.player
			else
				player=self:CreateBroadsideNPC(i)
			end
			local broadside=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Overhead.new()
			broadside:Setup(self.groupdancemodule.environment)
			broadside.groupdancemodule=self.groupdancemodule
			broadside.x=player.x
			broadside.y=player.y		
			broadside.player=player
		end
		if(r~=4 and self.groupdancemodule.mode_choice==1)then
			local iconsize="20"
			local icon="\124Tinterface\\icons\\ability_mage_arcanebarrage_nightborne:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:288218\124h[Broadside]\124h\124r"			
			local message=icon..""..link.." on you — move away!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)	
			for j=1,3 do
				local gdm=self.groupdancemodule
				local jaina=gdm.jaina
				local dist=math.sqrt(jaina.x*jaina.x+jaina.y*jaina.y)
				local xbase=jaina.x
				local ybase=jaina.y
				local angle=math.atan2(jaina.y,jaina.x)
				local fleeindex=j-2	--between -1 and 1
				local fleeangle=angle+math.pi+(fleeindex*math.pi/3)
				local x1,y1=xbase+math.cos(fleeangle)*yard*10,ybase+math.sin(fleeangle)*yard*10
				local x2,y2=xbase+math.cos(fleeangle)*yard*20,ybase+math.sin(fleeangle)*yard*20
		
				local arrow=gdm:Arrow(x1,y1,x2,y2,10,20,1,1,1,1,5)
			end
		end		
	end
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED)
	end
	function class:CompleteCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED_FINISH)
	end	
	
	
	
	
	function class:CreateBroadsideNPC(index)
		local newplayer=TRAININGGROUNDS_PlayerCharacter.new()
		newplayer:Setup(self.groupdancemodule.environment)
		--tinsert(self.groupdancemodule.raid.players,newplayer)
		if(not TRAININGGROUNDS_DEBUG.nonrandomraiderappearance)then newplayer:SetRandomAppearance() end
		newplayer.combat=TRAININGGROUNDS_CombatModule_SampleClass_MDPS.new()
		newplayer.combat:Setup(newplayer)						
		local jaina=self.groupdancemodule.jaina
		local angle=math.atan2(jaina.y,jaina.x)
		local dist=math.sqrt(jaina.x*jaina.x+jaina.y*jaina.y)
		local xbase=math.cos(angle)*(dist-yard*3)
		local ybase=math.sin(angle)*(dist-yard*3)
		local x=xbase+math.random()*yard*4-yard*2
		local y=ybase+math.random()*yard*4-yard*2
		newplayer.x=x;newplayer.y=y	
		newplayer.currentfacing=angle;newplayer.targetfacing=angle
		newplayer.expirytime=self.groupdancemodule.environment.localtime+8.0
		local fleeindex=index-2	--between -1 and 1
		local fleeangle=angle+math.pi+(fleeindex*math.pi/3)
		local targetx=newplayer.x+math.cos(fleeangle)*yard*30
		local targety=newplayer.y+math.sin(fleeangle)*yard*30
		newplayer.ai:SetTargetLocationAndPrecision({x=targetx,y=targety},yard*2)
		return newplayer
	end 
	
end









do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Telegraph_Broadside_Overhead=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Overhead
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=true
		-- self.width=250
		-- self.height=250		
		----------------
		self.player=nil
		self.groupdancemodule=nil
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Broadside_Overhead.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		self.x=self.player.x
		self.y=self.player.y
		self.z=yard*4
		if(self.alivetime>7.0)then
			local ground=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Ground.new()
			ground:Setup(self.environment)
			ground.groupdancemodule=self.groupdancemodule
			ground.x=self.x
			ground.y=self.y
			self:Die()			
		end		
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_Broadside_Overhead=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_Broadside_Overhead	

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		--self.modelfilename="spells/8fx_jaina_broadside_target.m2"	--projected texture :(
		--self.modelfilename="spells/8fx_jaina_arcane_novalow_impactworld.m2"	--!!! ground effect, not overhead	
		--self.modelfilename="spells/target_arcane_state_rimonly.m2"	--!!! ground effect, not overhead	
		self.modelfilename="spells/arrow_state_animated.m2"
		--self.modelfilename="spells/8fx_jaina_cannonmissile_arcane.m2"
		--self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		self.defaultanimation=0
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.5}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=500
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

local TELEGRAPH_SIZE=950
do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Telegraph_Broadside_Ground=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Ground
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=false
		self.targetsize=TELEGRAPH_SIZE
		----------------
		self.player=nil
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Broadside_Ground.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local mi=self.drawable.modelinfo
		if(mi.size<self.targetsize)then
			mi.size=mi.size+TELEGRAPH_SIZE*elapsed
			if(mi.size>self.targetsize)then mi.size=self.targetsize end
			self.drawable.width=mi.size
			self.drawable.height=mi.size			
		end
		if(self.alivetime>4.5 and self.state==1)then
			self.state=self.state+1
			local projectile=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Projectile.new()
			projectile:Setup(self.environment)
			projectile.x=self.x+yard*40
			projectile.y=self.y
			projectile.z=yard*40
			--print("projectile")
			projectile.xspeed=-yard*40*2
			projectile.zspeed=-yard*40*2
		end
		if(self.alivetime>5.0 and self.state==2)then
			self:Die()
			--TODO: hit detection
			if(self.groupdancemodule)then
				local player=self.groupdancemodule.player
				local distx=player.x-self.x
				local disty=player.y-self.y
				local distsqr=distx*distx+disty*disty
				if(distsqr<=yard*10*yard*10)then
					self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_BROADSIDE,
					source=self.groupdancemodule.player.combat})
				end
			end
		end		
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_Broadside_Ground=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_Broadside_Ground	

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/target_arcane_state_rimonly.m2"	--!!! ground effect, not overhead	
		self.defaultanimation=158
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.5}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=10		
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Telegraph_Broadside_Projectile=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Projectile
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.ysortable=true		
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Broadside_Projectile.new()		
		self.drawable:Setup(self,self.environment)
	end	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.z<=0)then
			--print("projectile dies")
			local impact=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Impact.new()
			impact:Setup(self.environment)
			impact.x=self.x;impact.y=self.y;impact.z=0
			self:Die()			
		end		
	end	
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_Broadside_Projectile=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_Broadside_Projectile

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		--self.modelfilename="spells/8fx_jaina_cannonmissile_arcane.m2"	--!!! ground effect, not overhead	
		self.modelfilename="spells/8fx_jaina_cannonmissile.m2"	--!!! ground effect, not overhead	
		self.defaultanimation=158
		self.camera2Dlocation={20*.707,20*.707,40}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,0}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=300
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Telegraph_Broadside_Impact=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_Broadside_Impact
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.ysortable=true		
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Broadside_Impact.new()		
		self.drawable:Setup(self,self.environment)
	end	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.alivetime>=1.0)then			
			self:Die()			
		end		
	end	
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_Broadside_Impact=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_Broadside_Impact

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_jaina_arcane_novalow_impactworld.m2"	--!!! ground effect, not overhead	
		self.defaultanimation=0
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.5}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=TELEGRAPH_SIZE
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end