
local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
local BEAMTURNSPEED=math.pi/64*(2/3)

do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_JAINA_Spell_GlacialRay=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Spell_GlacialRay
	
	function class:GetName()
		return "Glacial Ray"
	end		
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		-- cast duration is currently based on animation timing
		self.basecastduration=2.5
		self.range=nil
		--TODO: does not set GCD, is not affected by GCD
		self.basegcd=1.0	-- taeshtech GCD is applied at the END of the cast
		self.blockqueueingwhilecasting=true
	end
	
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end
	
	function class:StartCasting(caststarttime)		
		local caster=self.castercombat.owner
		--face towards player, or thereabouts
		local gdm=caster.groupdancemodule
		local player=gdm.player			
		local playerangle=math.atan2(player.y-caster.y,player.x-caster.x)	
		--print("angle:",playerangle)
		local targetangle=playerangle+math.random()*math.pi/8-math.pi/16
		--targetangle=0--!!!
				

				
		self.angle=targetangle
		caster.targetfacing_3D=targetangle
		local aura=self.castercombat:ApplyAuraByClass(TRAININGGROUNDS_Aura_Facing_Direction_WhileCasting,self.castercombat)
		aura.turnspeed=10
		aura.targetfacing=targetangle		
		
		super.StartCasting(self,caststarttime)
		self:ApplyGCD(caststarttime)
		self.telegraph=TRAININGGROUNDS_JAINA_Telegraph_GlacialRay.new()
		self.telegraph:Setup(gdm.environment)
		self.telegraph.castercombat=self.castercombat
		self.telegraph.spellinstance=self
		self.telegraph.x=self.castercombat.owner.x+yard*2.5*math.cos(targetangle)
		self.telegraph.y=self.castercombat.owner.y+yard*2.5*math.sin(targetangle)	
		self.telegraph.xbase=self.castercombat.owner.x
		self.telegraph.ybase=self.castercombat.owner.y		
		local direction
		if(math.random()>.5)then direction=1 else direction=-1 end
		self.direction=direction
		self.telegraph.direction=direction
		self.telegraph.drawable.frame:SetFacing(targetangle)
		self.telegraph.angle=targetangle
		--telegraph.expiry=caststarttime+3.0
		
		-- freezeangle is used for hintarrows
		-- the very first freezeangle is also used for the raid self-freeze		
		gdm.freezeangle=targetangle+direction*3*BEAMTURNSPEED 
		
		
		--TODO: face middle of room?
	end		
	
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED)
	end
	
	-- function class:CompleteCasting(castendtime)
		-- super.CompleteCasting(self,castendtime)
	-- end
	
	function class:CompleteCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED_FINISH)
	end	
	
	function class:ExecuteSpellEffect(projectile)
		local castermobile=self.castercombat.owner
		local targetx,targety

		local dust=TRAININGGROUNDS_JAINA_Decor_GlacialRay.new()
		local caster=self.castercombat.owner
		--print("Caster:",caster,caster.environment)
		dust:Setup(caster.environment)
		dust.x=self.telegraph.x;dust.y=self.telegraph.y		
		dust.xbase=self.castercombat.owner.x
		dust.ybase=self.castercombat.owner.y		
		dust.angle=self.angle
		dust.currentfacing=dust.angle
		dust.direction=self.direction
		--dust.drawable.frame:SetFacing(dust.currentfacing)
		dust.groupdancemodule=caster.groupdancemodule
		--self.telegraph.dust=dust
		dust.expirytime=dust.environment.localtime+6.5
		--TODO: actually check if the attack hit the player

	end	
end



do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_JAINA_Telegraph_GlacialRay=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_GlacialRay
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.nexthitdetecttime=0
		self.ysortable=true	--TODO: is this redundant?
		-- self.width=250
		-- self.height=250		
	end
	function class:Setup(owner,environment)
		super.Setup(self,owner,environment)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_GlacialRay_Telegraph.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local ANIM_TIME=2.500
		if(self.state==1 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.nexthitdetecttime=self.alivetime
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2)then		
			self.angle=self.angle+BEAMTURNSPEED*elapsed*self.direction
			
			if(self.alivetime>=self.nexthitdetecttime)then
				self.nexthitdetecttime=self.nexthitdetecttime+0.5			
				local cone=TRAININGGROUNDS_JAINA_FakeVoidZone_ArcticGround_Cone.new()
				cone:Setup(self.castercombat.owner.environment,self.spellinstance)
				local x1,y1=self.castercombat.owner.x,self.castercombat.owner.y
				local CONE_LENGTH=yard*100
				local CONE_ARC=math.pi/256
				local x2,y2=x1+CONE_LENGTH*math.cos(self.angle-CONE_ARC),y1+CONE_LENGTH*math.sin(self.angle-CONE_ARC)
				local x3,y3=x1+CONE_LENGTH*math.cos(self.angle+CONE_ARC),y1+CONE_LENGTH*math.sin(self.angle+CONE_ARC)	
				cone:SetVertices(x1,y1,x2,y2,x3,y3)		
				--hit detection
				local player=self.castercombat.owner.groupdancemodule.player
				local hit=false				
				-- we checked point-triangle collision, but for our purposes, player character is a circle, not a point
				local PLAYERRADIUS=yard*1.5
				local cx=player.x
				local cy=player.y
				---- change of plans: beam hit detection uses line-circle, not triangle-circle
				-- if(TRAININGGROUNDS_PointTriangleCollision(player.x,player.y,x1,y1,x2,y2,x3,y3)
				-- or TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,cx,cy,PLAYERRADIUS)
				-- or TRAININGGROUNDS_LineCircleCollision(x1,y1,x3,y3,cx,cy,PLAYERRADIUS)
				-- or TRAININGGROUNDS_LineCircleCollision(x2,y2,x3,y3,cx,cy,PLAYERRADIUS))then
					-- hit=true
				-- end
				local BEAMRADIUS=yard*0
				local x4,y4=x1+CONE_LENGTH*math.cos(self.angle),y1+CONE_LENGTH*math.sin(self.angle)
				
				if(TRAININGGROUNDS_LineCircleCollision(x1,y1,x4,y4,cx,cy,PLAYERRADIUS+BEAMRADIUS)) then
					hit=true
				end
				
				if(hit)then
					local gdm=self.castercombat.owner.groupdancemodule
					gdm:ReactToCustomDanceEvent({action=TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_GLACIALRAY,
						source=player.combat})		
					gdm:ApplyChillingTouchStacks(5,true)
				end		
				if(self.alivetime>ANIM_TIME+6.0)then
					self.state=self.state+1
					self.drawable:SetAnimationByNumber(159)
				end
			end
			self.x=self.castercombat.owner.x+yard*2.5*math.cos(self.angle)
			self.y=self.castercombat.owner.y+yard*2.5*math.sin(self.angle)
			self.castercombat.owner.currentfacing=self.angle
			self.drawable.frame:SetFacing(self.angle)
		end
		if(self.state==3 and self.alivetime>ANIM_TIME+6.0+0.5)then
			self.state=self.state+1
			self:Die()
		end
		
		
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_GlacialRay_Telegraph=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_GlacialRay_Telegraph

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_jaina_glacialray_precast.m2"
		 self.camera2Dlocation={0,-40,40*.707}	--TODO: use camera ystretch
		 self.camera2Dtarget={0,-2,0}		
		 self.modelcentertransform=true
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=350
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end









do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_JAINA_Decor_GlacialRay=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Decor_GlacialRay
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=true	
	end
	function class:Setup(owner,environment)
		super.Setup(self,owner,environment)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Decor_GlacialRay.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		self.currentfacing=self.currentfacing+BEAMTURNSPEED*elapsed*self.direction
		local facing=self.currentfacing
		
		--local facing=self.alivetime--!!!
		self.drawable.frame:SetFacing(facing+math.pi)
		
		self.x=self.xbase+math.cos(facing)*yard*19
		self.y=self.ybase+math.sin(facing)*yard*19*.85+yard*2
		-- self.x=self.xbase+math.cos(facing)*yard*50
		-- self.y=self.ybase+math.sin(facing)*yard*50*.85+yard*4
		
		local ANIM_TIME=2.000
		if(self.state==1 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.nexthitdetecttime=self.alivetime
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>6.0)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		end
		if(self.state==3 and self.alivetime>6.0+0.5)then 
			self.state=self.state+1
			self:Die()
		end
		
		
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_Decor_GlacialRay=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_Decor_GlacialRay	

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		--self.modelfilename="spells/8fx_jaina_glacialray_precast.m2"		
		self.modelfilename="spells/8fx_jaina_glacialray_cast.m2"		
		self.defaultanimation=0	
		-- self.camera2Dlocation={36,500,500*.707}	--TODO: use camera ystretch
		-- self.camera2Dtarget={36,0,0}
		self.camera2Dlocation={0,500,500*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,0}
		-- self.camera2Dlocation={0,200,200*.707}	--TODO: use camera ystretch
		-- self.camera2Dtarget={0,0,0}		
		
		self.modelcentertransform=true
		
		self.defaultanimation=0
		
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=1500
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

--[[
/run DressUpModel:SetModel("spells/8fx_jaina_glacialray_cast.m2");
DressUpModel:MakeCurrentCameraCustom();
DressUpModel:SetCameraPosition(4.3,0,10.8)
]]--

--[[
/run print(DressUpModel:GetCameraPosition());
print(DressUpModel:GetCameraTarget());
]]--
