--TODO NEXT: save groupdancemodule so we can run collision detection against player

local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_JAINA_Spell_OrbOfFrost=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Spell_OrbOfFrost
	
	function class:GetName()
		return "Orb of Frost"
	end		
	
	function class:SetCustomInfo()
		-- wowhead database says 25yd range
		super.SetCustomInfo(self)
		-- cast duration is currently based on animation timing
		self.basecastduration=5
		self.range=nil
		--TODO: does not set GCD, is not affected by GCD
		self.basegcd=1.0	-- taeshtech GCD is applied at the END of the cast
		self.blockqueueingwhilecasting=true
	end
	
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end
	
	function class:StartCasting(caststarttime)		
		local caster=self.castercombat.owner
		--face towards center
		--TODO: watch videos, figure out exactly how she faces
		local angle=math.atan(-caster.y,-caster.x)		
		self.angle=angle
		caster.targetfacing_3D=angle
		local aura=self.castercombat:ApplyAuraByClass(TRAININGGROUNDS_Aura_Facing_Direction_WhileCasting,self.castercombat)
		aura.turnspeed=10
		aura.targetfacing=angle
		
		
		super.StartCasting(self,caststarttime)
		self:ApplyGCD(caststarttime)
		--self.castercombat:ApplyAuraByClass(TRAININGGROUNDS_Aura_Facing_CombatTarget_WhileCasting,self.castercombat)
		local telegraph=TRAININGGROUNDS_JAINA_Telegraph_OrbOfFrost
		self.telegraph=telegraph
		
		telegraph:Setup(caster.environment)
		telegraph.x=self.castercombat.owner.x+yard*6*math.cos(angle)
		telegraph.y=self.castercombat.owner.y+yard*6*math.sin(angle)
		
		telegraph.angle=angle
		--telegraph.expiry=caststarttime+3.0
		
		--TODO: face middle of room?
		
		local gdm=self.castercombat.owner.groupdancemodule
		if(gdm.mode_choice==1)then
			local iconsize="20"
			local icon="\124Tinterface\\icons\\ability_mage_arcanebarrage_nightborne:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:288619\124h[Orb of Frost]\124h\124r"			
			local message=icon..""..link.." — soak it!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)			
			
			local arrow=gdm:Arrow(gdm.player.x,gdm.player.y,telegraph.x,telegraph.y,10,20,1,1,1,1,5)
		end
		
	end		
	
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED)
	end
	
	function class:CompleteCasting(castendtime)
		super.CompleteCasting(self,castendtime)
		local orb=TRAININGGROUNDS_JAINA_OrbOfFrost_Projectile.new()
		local caster=self.castercombat.owner
		--print("Caster:",caster,caster.environment)
		orb:Setup(caster.environment)
		orb.x=self.telegraph.x;orb.y=self.telegraph.y		
		orb.angle=self.angle
		orb.groupdancemodule=caster.groupdancemodule
	end
	
	function class:CompleteCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED_FINISH)
	end	
	
	function class:ExecuteSpellEffect(projectile)
		--TODO: apply debuff and knockback
		--TODO: if player soaks wrong flame rend, call wipe	
		local castermobile=self.castercombat.owner
		local targetx,targety

	end	
end



do
	local super=TRAININGGROUNDS_Telegraph
	TRAININGGROUNDS_JAINA_Telegraph_OrbOfFrost=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_OrbOfFrost
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=false	--TODO: is this redundant?
		-- self.width=250
		-- self.height=250
	end
	function class:Setup(owner,environment)
		super.Setup(self,owner,environment)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_OrbOfFrost_Telegraph.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local ANIM_TIME=5.000
		if(self.state==1 and self.alivetime>ANIM_TIME)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)
		end
		if(self.alivetime>ANIM_TIME+0.5)then
			self:Die()
		end		
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_OrbOfFrost_Telegraph=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_OrbOfFrost_Telegraph	

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		-- Frozen Orb telegraph
		self.modelfilename="spells/8fx_jaina_frozenorb_precast.m2"		
		self.scale3D=0.25	--TODO: probably move to modelinfo
		self.positionmultiplier=0.45/self.scale3D	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		--self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		self.defaultanimation=0	
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dlocation={0,80,80*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,0}		
		self.camera2Dtarget={0,0,-0.5}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=500
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_OrbOfFrost_Projectile=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_OrbOfFrost_Projectile
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.nexthitdetecttick=0
		self.state=1
		self.ysortable=true
		self.targetsize=250
		self.hp=2
		-- set after calling setup:
		self.groupdancemodule=nil
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_OrbOfFrost_Projectile.new()		
		self.drawable:Setup(self,self.environment)
	end
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.state==1)then
			self.state=self.state+1
			local ORB_SPEED=2.5
			self.xspeed=math.cos(self.angle)*yard*ORB_SPEED
			self.yspeed=math.sin(self.angle)*yard*ORB_SPEED
		end
		if(self.state==2 and self.alivetime>3.0)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)
		end			
			local mi=self.drawable.modelinfo
			if(mi.size>self.targetsize)then
				mi.size=mi.size-elapsed*75
				if(mi.size<self.targetsize)then mi.size=self.targetsize end
				if(mi.size<=50)then
					mi.size=50
					if(self.alivetime<20.0)then self.alivetime=20.0 end
				end		
				self.drawable.width=mi.size
				self.drawable.height=mi.size
			end
		if(self.state==3 and self.alivetime>20.0)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(159)			
		end
		if(self.state==4 and self.alivetime>20.3)then
			if(self.groupdancemodule)then
				if(self.hp==0)then
					self.groupdancemodule:ApplyChillingTouchStacks(1,false)
				else
					self.groupdancemodule:ApplyMassFrozenSolid()
				end
				--TODO: apply stacks to raid
			end
			self:Die()
		end
		
		--hitdetection
		if(self.groupdancemodule)then
			if(self.targetsize>50)then
				if(self.alivetime>=self.nexthitdetecttick)then	
					local player=self.groupdancemodule.player
					local distsqr=(player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y)
					if(distsqr<=yard*5*yard*5)then
						self.nexthitdetecttick=self.alivetime+1.0
						self.groupdancemodule:ApplyChillingTouchStacks(1,false)
						self.targetsize=self.targetsize-100
						self.hp=self.hp-1
					end
				end
			end
		end
		
		
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_OrbOfFrost_Projectile=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_OrbOfFrost_Projectile	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		-- Frozen Orb projectile
		self.modelfilename="spells/8fx_jaina_frozenorb_state.m2"		
		self.scale3D=0.25	--TODO: probably move to modelinfo
		self.positionmultiplier=0.45/self.scale3D	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		--self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		self.defaultanimation=0	
		self.camera2Dlocation={0,60,60*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.5}			
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=250
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end