
local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

--Spell is "fake" -- prismatic images are spawned by GDM
do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_JAINA_Spell_PrismaticImage=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Spell_PrismaticImage
	
	function class:GetName()
		return "Prismatic Image"
	end		
	
	function class:SetCustomInfo()
		-- wowhead database says 25yd range
		super.SetCustomInfo(self)
		-- cast duration is currently based on animation timing
		self.basecastduration=1.0
		self.range=nil
		--TODO: does not set GCD, is not affected by GCD
		self.basegcd=1.0	-- taeshtech GCD is applied at the END of the cast
		self.blockqueueingwhilecasting=true
	end
	
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end
	
	function class:StartCasting(caststarttime)		
		local caster=self.castercombat.owner
		
		super.StartCasting(self,caststarttime)
		self:ApplyGCD(caststarttime)
	
		TRAININGGROUNDS_FakeDBM_RaidBossEmote("(Jaina is casting Prismatic Image.)",2.0,true)

	end		
	
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED)
	end
	
	
	function class:CompleteCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED_FINISH)
	end	
end



do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_JAINA_Mobile_PrismaticImage=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Mobile_PrismaticImage

	function class:GetName()
		--override, don't call super
		return "Prismatic Image (mobile) "..tostring(self.id)		
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Jaina.new()
		self.drawable:Setup(self,self.environment)
	end	

end



function TRAININGGROUNDS_JAINA_PrismaticImage_ApplyPrismaticImage(groupdancemodule)
	local image	
	local angle=math.atan(groupdancemodule.jaina.y,groupdancemodule.jaina.x)
	local anglemodifier=math.random()*math.pi*3/4+math.pi*1/4
	if(math.random()>0.5)then anglemodifier=-anglemodifier end
	local newangle=angle+anglemodifier
	image=TRAININGGROUNDS_JAINA_Mobile_PrismaticImage.new()
	image:Setup(groupdancemodule.environment)
	image.x=math.cos(newangle)*yard*40
	image.y=math.sin(newangle)*yard*40
	image.expirytime=groupdancemodule.environment.localtime+15.0
	image.currentfacing=newangle+math.pi
		
	if(groupdancemodule.mode_choice==1)then
		local iconsize="20"
		local icon="\124Tinterface\\icons\\ability_socererking_arcanemines:"..iconsize.."\124t"
		local link="\124cffff0000\124Hspell:288747\124h[Prismatic Image]\124h\124r"			
		local message=icon.."A "..link.." appears nearby.  Use the scroll wheel and arrow keys to find it!"
		TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)		
	end
	
	return image
end


	