local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_Spell_SampleMeleeAttack
	TRAININGGROUNDS_JAINA_Spell_SiegebreakerBlast=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Spell_SiegebreakerBlast
	function class:GetName()
		return "SiegebreakerBlast"
	end		
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.basecastduration=1.0
		self.range=nil
		self.basegcd=1.0	-- taeshtech GCD is applied at the END of the cast
		self.blockqueueingwhilecasting=true
	end
	function class:SetQueuedTarget()	
		-- do nothing; targetless spell
	end
	function class:NewCast()
		local spellinstance=super.NewCast(self)
		spellinstance.groupdancemodule=self.groupdancemodule
		return spellinstance
	end	
	function class:StartCasting(caststarttime)		
		local caster=self.castercombat.owner
		super.StartCasting(self,caststarttime)
		self:ApplyGCD(caststarttime)		
	end		
	function class:CompleteCastingEffect(castendtime)
		--50% chance player is targeted 
		local r=2
		--50% chance player isn't targeted and we create a 3rd NPC instead
		if(math.random()>0.5)then r=1 end		
		for i=2,2 do
			local player
			if(i==r)then
				player=self.groupdancemodule.player
			else
				player=self:CreateSiegebreakerBlastNPC(i)
			end
			local broadside=TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Overhead.new()
			broadside:Setup(self.groupdancemodule.environment)
			broadside.groupdancemodule=self.groupdancemodule
			broadside.x=player.x
			broadside.y=player.y		
			broadside.player=player
			
			local iconsize="20"
			local icon="\124Tinterface\\icons\\inv_staff_53:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:288380\124h[Siegebreaker Blast]\124h\124r"			
			local playername="someone"
			if(i==r)then
				playername="\124cffff0000"..GetUnitName("player").."\124r"
			end
			local message=icon.."\124cffff0000Lady Jaina Proudmoore\124r marks "..playername.." for a massive "..link.."!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)			
			if(i==r)then
				local gdm=self.groupdancemodule
				for j=1,3 do					
					local jaina=gdm.jaina
					local dist=math.sqrt(jaina.x*jaina.x+jaina.y*jaina.y)
					local xbase=jaina.x
					local ybase=jaina.y
					local angle=math.atan2(jaina.y,jaina.x)
					local fleeindex=j-2	--between -1 and 1
					local fleeangle=angle+math.pi+(fleeindex*math.pi/3)
					local x1,y1=xbase+math.cos(fleeangle)*yard*10,ybase+math.sin(fleeangle)*yard*10
					local x2,y2=xbase+math.cos(fleeangle)*yard*30,ybase+math.sin(fleeangle)*yard*30
			
					local arrow=gdm:Arrow(x1,y1,x2,y2,10,20,1,1,1,1,5)
				end			
			end
		end
	end
	function class:BeginCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED)
	end
	function class:CompleteCastingAnimationFunction()	
		self.castercombat.owner.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.SPELLCAST_DIRECTED_FINISH)
	end	
	
	
	
	
	function class:CreateSiegebreakerBlastNPC(index)
		local newplayer=TRAININGGROUNDS_PlayerCharacter.new()
		newplayer:Setup(self.groupdancemodule.environment)
		--tinsert(self.groupdancemodule.raid.players,newplayer)
		if(not TRAININGGROUNDS_DEBUG.nonrandomraiderappearance)then newplayer:SetRandomAppearance() end
		newplayer.combat=TRAININGGROUNDS_CombatModule_SampleClass_MDPS.new()
		newplayer.combat:Setup(newplayer)						
		local jaina=self.groupdancemodule.jaina
		local angle=math.atan2(jaina.y,jaina.x)
		local dist=math.sqrt(jaina.x*jaina.x+jaina.y*jaina.y)
		local xbase=math.cos(angle)*(dist-yard*3)
		local ybase=math.sin(angle)*(dist-yard*3)
		local x=xbase+math.random()*yard*4-yard*2
		local y=ybase+math.random()*yard*4-yard*2
		newplayer.x=x;newplayer.y=y	
		newplayer.currentfacing=angle;newplayer.targetfacing=angle
		newplayer.expirytime=self.groupdancemodule.environment.localtime+8.0
		local fleeindex=math.floor(math.random()*3)-1	--between -1 and 1
		local fleeangle=angle+math.pi+(fleeindex*math.pi/3)
		local targetx=newplayer.x+math.cos(fleeangle)*yard*50
		local targety=newplayer.y+math.sin(fleeangle)*yard*50
		newplayer.ai:SetTargetLocationAndPrecision({x=targetx,y=targety},yard*2)
		return newplayer
	end 
	
end




local TELEGRAPH_SIZE=950*2





do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Overhead=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Overhead
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.ysortable=false
		-- self.width=250
		-- self.height=250		
		----------------
		self.player=nil
		self.groupdancemodule=nil
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Overhead.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		self.x=self.player.x
		self.y=self.player.y
		self.z=0
		if(self.state==1 and self.alivetime>0.25)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)
		end
		if(self.state==2 and self.alivetime>7.0)then
			self.state=self.state+1
			local projectile=TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Projectile.new()
			projectile:Setup(self.environment)
			projectile.x=self.x+yard*40
			projectile.y=self.y
			projectile.z=yard*40
			--print("projectile")
			projectile.xspeed=-yard*40*2
			projectile.zspeed=-yard*40*2
			projectile.groupdancemodule=self.groupdancemodule
			self.drawable:SetAnimationByNumber(159)
		end		
		if(self.state==3 and self.alivetime>7.5)then
			self:Die()					
		end
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Overhead=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Overhead	

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/target_arcane_state_centeronly.m2"
		self.defaultanimation=0
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.5}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=TELEGRAPH_SIZE*2
	end
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
end



do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Projectile=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Projectile
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.ysortable=true		
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Projectile.new()		
		self.drawable:Setup(self,self.environment)
	end	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.z<=0)then
			--print("projectile dies")
			local impact=TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Impact.new()
			impact:Setup(self.environment)
			impact.x=self.x;impact.y=self.y;impact.z=0
			
			--hit detection.  
			-- for now, just knockback.			
			local player=self.groupdancemodule.player			
			local distsqr=(player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y)
			local dist=math.sqrt(distsqr)
			--if(dist<=yard*40)then
			if(true)then
				local angle=math.atan2(player.y-self.y,player.x-self.x)
				--knockback, but only if player isn't frozen
				local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSolid)
				if(#auras==0)then					
					player.zspeed=yard*11.7
					if(player.z<1)then player.z=1 end
					player.xspeed=math.cos(angle)*yard*10
					player.yspeed=math.sin(angle)*yard*10
				end
			-- TODO LATER: flash red if too close AND player wasn't the one targeted...
			end
			
			self:Die()			
		end		
	end	
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Projectile=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Projectile

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_jaina_cannonmissile_arcane.m2"
		self.defaultanimation=158
		self.camera2Dlocation={20*.707,20*.707,40}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,0}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		--self.modelinfo.size=300
		self.modelinfo.size=500
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Impact=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Telegraph_SiegebreakerBlast_Impact
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.ysortable=true		
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Impact.new()		
		self.drawable:Setup(self,self.environment)
	end	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.alivetime>=1.0)then			
			self:Die()			
		end		
	end	
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Impact=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JAINA_Drawable_SiegebreakerBlast_Impact

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/8fx_jaina_arcane_novahigh_impactworld.m2"	--!!! ground effect, not overhead	
		self.defaultanimation=0
		self.camera2Dlocation={0,40,40*.707}	--TODO: use camera ystretch
		self.camera2Dtarget={0,0,-0.5}		--!!!
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=TELEGRAPH_SIZE
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end