

--TODO NEXT: ysortable=true

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_OPULENCE_Decor_FlamesOfPunishment=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_OPULENCE_Decor_FlamesOfPunishment
	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.angle=0	--set by creator function after calling setup
		self.ysortable=true
		self.hitdetect=true
		-- these are set by the calling function.  if targetplayer is nil, flame is purely decorative.
		self.targetplayer=nil
		self.miniboss=nil
		self.conewidth=nil	
		self.groupdancemodule=nil
	end

	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_OPULENCE_Drawable_FlamesOfPunishment.new()
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		--TODO: add animationsystem to spelleffects so we don't have to do all this
		super.Step(self,elapsed)
		
		if(self.hitdetect and self.targetplayer)then
			self.hitdetect=false

			
			
			local playerangle=math.atan2(self.targetplayer.y-self.miniboss.y,self.targetplayer.x-self.miniboss.x)
			local leeway=self.conewidth/2
			local difference=self.angle-playerangle
			local hit=false
			difference=TRAININGGROUNDS_Atan2Modulo(difference)	
			difference=math.abs(difference)
			--print("Difference:",difference,"Leeway:",leeway)
			if(difference<=leeway)then			
				hit=true
			else
				-- we checked point-cone collision, but for our purposes, player character is a circle, not a point
				local PLAYERRADIUS=yard*1.5
				local x1=self.miniboss.x
				local y1=self.miniboss.y
				local x2=x1+math.cos(self.angle-leeway)*yard*200
				local y2=y1+math.sin(self.angle-leeway)*yard*200
				local cx=self.targetplayer.x
				local cy=self.targetplayer.y
				--print("linecircle:",x1,y1,x2,y2)
				if(TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,cx,cy,PLAYERRADIUS))then
					hit=true
				else
					x2=x1+math.cos(self.angle+leeway)*yard*200
					y2=y1+math.sin(self.angle+leeway)*yard*200				
					--print("linecircle2:",x1,y1,x2,y2)
					if(TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,cx,cy,PLAYERRADIUS))then
						hit=true
					end
				end

			end			
			if(hit)then
				self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_OPULENCE_CustomDanceEventType.HIT_BY_FLAMESOFPUNISHMENT,
									source=self.targetplayer.combat})			
			end
		end
		
		self.alivetime=self.alivetime+elapsed
		local END_TIME=0.85
		if(self.alivetime>END_TIME)then		
			self:Die() 
		end
	end
end


do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_OPULENCE_Drawable_FlamesOfPunishment=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_OPULENCE_Drawable_FlamesOfPunishment
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		--self.name="FlamesOfPunishment (spelleffect)"
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="spells/8fx_vaultguardian_flames_impact.m2"		
		self.scale3D=1	--TODO: probably move to modelinfo
		self.positionmultiplier=0.95	--TODO: move to modelinfo
		--self.zsortoffset3D=0.5	--measured in yards.  TODO: move to modelinfo
		self.zsortoffset3D=0
		
	end
	
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
	
	function class:Get3DPositionCoords()
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		--print("Flames angle:",self.owner.currentfacing)
		local radius=450/2
		--local newx=self.x+math.cos(self.owner.currentfacing)*radius
		--local newy=self.y+radius-math.sin(self.owner.currentfacing)*radius
		local newx=self.x+radius+math.cos(self.owner.currentfacing)*radius
		local newy=self.y+math.sin(self.owner.currentfacing)*radius
		local newz=self.z+yard*0.25
		--local newx=0
		--local newy=0
		--local newz=self.z+yard*0.25

		return newx,newy,newz
	end	
	
	function class:GetFacingRadians()
		return self.owner.currentfacing+math.pi
	end
	
	
	
end