

do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_OPULENCE_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_OPULENCE_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_OPULENCE_CustomDanceEventType.HIT_BY_FLAMESOFPUNISHMENT=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_OPULENCE_GroupDanceModule_FlamesOfPunishment=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_OPULENCE_GroupDanceModule_FlamesOfPunishment
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.mode_choice=nil
		self.cast_time=4.0
		self.channel_time=6.5
		self.total_ticks=12
		self.spin_per_tick=math.pi*2/12
		self.conewidth=math.pi*2/6
		self.flamecount=1
		self.turnspeed=2.0
		
		self.slamoffset=0		-- random amount turned before slam animation begins.  not sure if true to game.  up to pi/4 radians towards direction of slam.
									--slamoffset is multiplied by slamdirection before applying it.
		self.slamdirection=0	-- direction of slam.  -1 or 1.  slam is always pi/4 radians away from currentfacing_3d (which itself is modified by slamoffset).
		self.playerisdead=false
	end


	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment

		self.miniboss=self.bosscontroller.minibossflames	
	
		self.raid:CreatePlayers(environment,0,0,0,1)		
		--self.raid:MakeAllPlayersIrrelevant()
		
		-- for now, no autoattacks.
		for i=1,#self.raid.players do
			self.raid.players[i].combat.autoattackmodule:Cleanup()
			self.raid.players[i].combat.autoattackmodule=nil
		end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]
		--self.raid.players[1].currentfacing=math.pi
		--self.raid.players[1].currentfacing_3D=self.raid.players[1].currentfacing
		
		self.centercircles={}
		
		
		self.floor=TRAININGGROUNDS_OPULENCE_Decor_FlamesFloor.new()
		self.floor:Setup(environment)

		
		-- local skybox=TRAININGGROUNDS_OPULENCE_Decor_JadefireSkybox.new()
		-- skybox:Setup(environment)
		-- skybox.x=0;skybox.y=0;skybox.z=0


		
		--TODO: set self.wmcontroller during setup
		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.player.x=0
		self.player.y=-yard*5
		self.player.currentfacing=math.pi/2	-- facing "north" for 3D camera
		self.player.currentfacing_3D=self.player.currentfacing
		self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing
		
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		local totaltime=0
		if(self.mode_choice>=1 and self.mode_choice<=4)then		
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+0.25
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				self:ResetPlayerDeathChecks()							
				self.miniboss.drawable:SetAnimation(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST.Stance)
			end
			tinsert(self.timedevents,event)		

		
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			--!!!
			totaltime=totaltime+self.cast_time	
			--totaltime=totaltime+0.5
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 		
				self.miniboss.drawable:SetAnimation(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST.FlamesOfPunishment)			
			end
			tinsert(self.timedevents,event)	
			
			for i=1,self.total_ticks do
				local event=TRAININGGROUNDS_TimedDanceEvent.new()
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 		
					local tickspin=self.spin_per_tick
					local targetfacing=self.miniboss.currentfacing_3D-tickspin
					if(targetfacing<-math.pi)then targetfacing=targetfacing+math.pi*2 end
					self.miniboss.baseturnspeed=self.turnspeed
					self.miniboss.baseturnspeed_3D=self.turnspeed				
					self.miniboss.currentfacing_3D=targetfacing
					self.miniboss.targetfacing_3D=targetfacing
				end
				tinsert(self.timedevents,event)				
			
				-- do not increment totaltime here
				local event=TRAININGGROUNDS_TimedDanceEvent.new()
				event.time=self.scenario.localtime+totaltime+0.3
				event.execute=function() 		
					self:SpawnFlames()
				end
				tinsert(self.timedevents,event)				
			
				totaltime=totaltime+self.channel_time/self.total_ticks
			
			end
			
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+0	-- we already added time at the end of the above loop
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 		
				self.miniboss.drawable:SetAnimation(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST.Stand)		
			end
			tinsert(self.timedevents,event)	
	
		
		----------------------------------------------------------------------------------------------------------------
		----------------------------------------------------------------------------------------------------------------
		--										SLAM
		----------------------------------------------------------------------------------------------------------------
		----------------------------------------------------------------------------------------------------------------
		elseif(self.mode_choice==5 or self.mode_choice==6)then
			local animname
			--reminder: 6 == positive offset == turn LEFT
			if(self.mode_choice==6)then animname="SlamLeft" else animname="SlamRight" end
			--print("anim:",animname)
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+0.25
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				self:ResetPlayerDeathChecks()			
				
				self.miniboss.targetfacing_3D=TRAININGGROUNDS_Atan2Modulo(self.miniboss.targetfacing_3D+self.slamoffset*self.slamdirection)
				self.miniboss.drawable:SetAnimation(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST[animname])				
			end
			tinsert(self.timedevents,event)		


			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+2.0
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				self:SpawnSlam()
			end
			tinsert(self.timedevents,event)	

			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+1.25
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				self.miniboss.drawable:SetAnimation(TRAININGGROUNDS_OPULENCE_ANIMATION_LIST.Stand)
			end
			tinsert(self.timedevents,event)	
	
		else
			----------------------------------------------------------------------------------------------------------------
			----------------------------------------------------------------------------------------------------------------
			--										LIQUID GOLD
			----------------------------------------------------------------------------------------------------------------
			----------------------------------------------------------------------------------------------------------------
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+0.25
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				self:ResetPlayerDeathChecks()	
				
				local iconsize="20"
				local icon="\124Tinterface\\icons\\ability_creature_amber_02:"..iconsize.."\124t"
				local link="\124cffff0000\124Hspell:287072\124h[Liquid Gold]\124h\124r"			
				local message=icon.."You are covered in "..link.."!"
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,true)		

				local aura=self.player.combat:ApplyAuraByClass(TRAININGGROUNDS_STORMWALLBLOCKADE_Aura_StormsWail,self.player.combat)
				aura.expiry=self.player.environment.localtime+5.0
			end
			tinsert(self.timedevents,event)	

			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+2
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				TRAININGGROUNDS_FakeDBM_RaidBossEmote("3",1.0,true)			
			end
			tinsert(self.timedevents,event)				
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+1
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				TRAININGGROUNDS_FakeDBM_RaidBossEmote("2",1.0,true)			
			end
			tinsert(self.timedevents,event)							
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+1
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				TRAININGGROUNDS_FakeDBM_RaidBossEmote("1",1.0,true)			
			end
			tinsert(self.timedevents,event)			
			
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+1
			event.time=self.scenario.localtime+totaltime	
			event.execute=function() 
				local player=self.player
				local dist=math.sqrt(player.x*player.x+player.y*player.y)/yard
				local diststr=string.format("%.1f",dist)
				local message="Dropped it "..diststr.."yd away."
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)
				if(dist<=17)then 
					self.playerisdead=true 
				end
			end
			tinsert(self.timedevents,event)		
			totaltime=totaltime+1
		end	
			
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+1
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 		
			local message
			if(self.playerisdead)then
				self.successesinarow=0
				message="Try again..."
			else
				self.successesinarow=self.successesinarow+1
				message="OK!"
			end
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
		end
		tinsert(self.timedevents,event)					

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+1
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 		
			if(	self.successesinarow>1)then
				local message="("..tostring(self.successesinarow).." in a row)"
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,false)
			end			
		end
		tinsert(self.timedevents,event)							

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+2
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 		
			self.scenario:ShowButtons()
		end
		tinsert(self.timedevents,event)	

	end
	
	
	
	function class:SpawnFlames()
		local a=0
		local b=0
		if(self.flamecount==3)then a=-1;b=1 end
		for i=a,b do
			local testeffect=TRAININGGROUNDS_OPULENCE_Decor_FlamesOfPunishment.new()
			testeffect:Setup(self.environment.game.environment_gameplay)	
			--local angle=(i)*(math.pi*2/6)+self.miniboss.currentfacing
			--TODO: why does currentfacing (not _3D) work here?
			local angle=(i)*(math.pi*3/6)+self.miniboss.currentfacing
			testeffect.x=math.cos(angle)*yard*1
			testeffect.y=math.sin(angle)*yard*1
			testeffect.z=0
			testeffect.currentfacing=angle
			testeffect.angle=angle
			if(i==0)then
				testeffect.targetplayer=self.player
				testeffect.conewidth=self.conewidth
				testeffect.miniboss=self.miniboss
				testeffect.groupdancemodule=self
			end
		end
	end
	
	function class:SpawnSlam()
		local a=-1
		local b=1
		for i=a,b do
			local testeffect=TRAININGGROUNDS_OPULENCE_Decor_FlamesOfPunishment.new()
			testeffect:Setup(self.environment.game.environment_gameplay)	
			local angle=(i)*(math.pi*3/6)+self.miniboss.currentfacing
			
			angle=angle+self.slamdirection*math.pi/4
			angle=TRAININGGROUNDS_Atan2Modulo(angle)
			--print("Slamdirection:",self.slamdirection,"Angle:",angle,"Facing:",self.miniboss.currentfacing,self.miniboss.currentfacing_3D)
			testeffect.x=math.cos(angle);testeffect.y=math.sin(angle);testeffect.z=0
			testeffect.currentfacing=angle;testeffect.angle=angle
			if(i==0)then
				testeffect.targetplayer=self.player
				testeffect.conewidth=math.pi*2/2
				testeffect.miniboss=self.miniboss
				testeffect.groupdancemodule=self
			end
		end
	end
		
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		-- mobile_fakemonkboss doesn't check whether it's hitting primary player, so check now
		if(event.source~=self.raid.players[1].combat)then return end
		
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		-- local targetcombat=event.target
		-- local targetmobile=nil
		-- if(targetcombat)then targetmobile=targetcombat.owner end
		-- local camera=self.multisidedstrike.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_OPULENCE_CustomDanceEventType.HIT_BY_FLAMESOFPUNISHMENT)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		else

		end
	end


	

	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
