local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_Telegraph_SeaSwell=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Telegraph_SeaSwell
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		--must set groupdancemodule after calling setup for hit detection to work
		self.groupdancemodule=nil
		--self.ysortable=true
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_SeaSwell.new()				
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.state==1 and self.alivetime>=0.25)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)
		elseif(self.state==2 and self.alivetime>=3.0)then
			self.state=self.state+1
			local ftp=TRAININGGROUNDS_STORMWALLBLOCKADE_Telegraph_FreezingTidepool.new()
			ftp:Setup(self.environment)
			ftp.x=self.x;ftp.y=self.y
			ftp.drawable.width=yard*8
			ftp.drawable.height=yard*8
			ftp.groupdancemodule=self.groupdancemodule
			self:Die()
		end		
	end
end


do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_SeaSwell=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_SeaSwell	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false				
		self.modelfilename="spells/target_water_state_centeronly.m2"
		--self.modelfilename="spells/warlock_demonicportal_green.m2"
		--self.scale3D=0.25	--TODO: probably move to modelinfo
		--self.positionmultiplier=0.45/self.scale3D	--TODO: move to modelinfo
		--self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		--self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		self.defaultanimation=0	
		self.camera2Dlocation={0,23,23*.707}	--TODO: use camera ystretch
		--self.camera2Dlocation={-23,0,23*.707}	--TODO: use camera ystretch
			-- must point at -1, not 0, or else telegraph will appear too low on screen
		self.camera2Dtarget={0,0,-1}			
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=250
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_Telegraph_FreezingTidepool=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Telegraph_FreezingTidepool
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		self.hitdetect=true
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite_Circle_Telegraph:new()
		self.drawable:Setup(self,self.environment)
		self.drawable:SetColor(1,1,1,1)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.state==1)then
			local c=1-self.alivetime
			if(c<0)then c=0 end
			local r=0.5+0.5*c
			local g=0.6+0.4*c
			local b=0.3+0.7*c
			self.drawable:SetColor(r,g,b,1)
			if(self.alivetime>=3+13+5)then
				self.state=self.state+1
				self:Die()
			else
				if(self.groupdancemodule)then
					--print("Time check:",self.groupdancemodule.scenario.localtime,self.groupdancemodule.stormswailendtime)
					if(self.hitdetect or self.groupdancemodule.scenario.localtime<=self.groupdancemodule.stormswailendtime)then						
						local player=self.groupdancemodule.player
						if(player.z==0)then
							local distsqr=(self.x-player.x)*(self.x-player.x)+(self.y-player.y)*(self.y-player.y)
							if(distsqr<=(yard*4)*(yard*4))then
								if(self.hitdetect)then
									self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_STORMWALLBLOCKADE_CustomDanceEventType.SEASWELL,
										source=player.combat})
								else							
									self.groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_STORMWALLBLOCKADE_CustomDanceEventType.SOAK_TIDEPOOL,
										source=player.combat})
									--self.groupdancemodule.tidepoolssoaked=self.groupdancemodule.tidepoolssoaked+1
									self:Die()						
								end
							end
						end
					end
					self.hitdetect=false
				end
			end
		end		
	end
end