

--TODO NEXT: ysortable=true

local EYE_TURNSPEED=0.05
local BEAM_DURATION=27.0

do	
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Eye=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Eye
	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.angle=0	--set by creator function after calling setup
		--self.ysortable=true
		self.state=0
		self.linewidth=yard*1		
		self.nextcollisioncheck=0
		self.baseturnspeed=EYE_TURNSPEED
		self.baseturnspeed_3D=EYE_TURNSPEED
		-- these are set by the calling function.  if targetplayer is nil, hit detection will be ignored.
		self.targetplayer=nil
		self.groupdancemodule=nil
		self.beam=nil
		--self.beamangle=nil
		self.turndirection=0		
		
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_UUNAT_Drawable_PiercingGaze_Eye.new()
		self.drawable:Setup(self,self.environment)
	end	
	function class:Step(elapsed)
		local END_TIME=BEAM_DURATION
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		--Animation states:
		if(self.state==0 and self.alivetime>=1.9)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)			
		elseif(self.state==1)then	
			self.currentfacing=self.currentfacing+EYE_TURNSPEED*self.turndirection*elapsed
			self.currentfacing_3D=self.currentfacing
			self.targetfacing_3D=self.currentfacing
		
			if(self.alivetime>END_TIME)then
				self.state=self.state+1
				self.drawable:SetAnimationByNumber(159)
			end
		elseif(self.state==2 and self.alivetime>END_TIME+1.9)then
			self.state=self.state+1
			self:Die()
		end
		--Hit detection:
		if(self.state==1)then
			if(self.alivetime>=self.nextcollisioncheck)then
				if(self.targetplayer and self.groupdancemodule)then				
					local player=self.targetplayer
					local beamangle=self.currentfacing_3D
					self.beam.x=self.x+math.cos(beamangle)*yard*25
					self.beam.y=self.y+math.sin(beamangle)*yard*25
					
					local x2=self.x+math.cos(beamangle)*yard*200
					local y2=self.y+math.sin(beamangle)*yard*200
					--print("x1,y1,x2,y2:",self.x,self.y,x2,y2,player.x,player.y,(player.hitboxradius+self.linewidth))
					if(TRAININGGROUNDS_LineCircleCollision(self.x,self.y,x2,y2,player.x,player.y,(player.hitboxradius+self.linewidth)))then
						--TODO: use voidzone tick system instead
						self.nextcollisioncheck=self.alivetime+2.0
						--print("hit:",GetTime())
						--self.collided_with_player=true
						self.groupdancemodule:ReactToCustomDanceEvent({
							action=TRAININGGROUNDS_UUNAT_CustomDanceEventType.HIT_BY_PIERCING,
							source=player.combat							
						})
					end
				end
			end
		end
		
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_UUNAT_Drawable_PiercingGaze_Eye=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_UUNAT_Drawable_PiercingGaze_Eye
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="spells/8fx_shrineraid_uunat_piercinggaze_eye.m2"		
		--self.modelfilename="spells/8fx_shrineraid_uunat_piercinggaze_beam.m2"		
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.5/self.scale3D	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.5
		--self.zsortoffset3D=0.5	--measured in yards.  TODO: move to modelinfo
		--self.defaultanimation=158
		self.defaultanimation=0
	end
	function class:SetFrameLayer()
		--self.framelayer=self.owner.environment.cameramanager.ysortframelayer
		self.framelayer=self.owner.environment.cameramanager.skybox2framelayer
	end
end



do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Beam=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Beam
	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.state=0
		self.alivetime=0
		self.angle=0	--set by creator function after calling setup
		self.ysortable=true
		self.hitdetect=true
		self.baseturnspeed=EYE_TURNSPEED
		self.baseturnspeed_3D=EYE_TURNSPEED
		-- set by groupdancemodule:
		self.turndirection=0
	end

	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_UUNAT_Drawable_PiercingGaze_Beam.new()
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		--TODO: add animationsystem to spelleffects so we don't have to do all this
		super.Step(self,elapsed)
		self.currentfacing=self.currentfacing+EYE_TURNSPEED*self.turndirection*elapsed
		self.currentfacing_3D=self.currentfacing
		self.targetfacing_3D=self.currentfacing
		
		local END_TIME=BEAM_DURATION
		self.alivetime=self.alivetime+elapsed
		--print("TUDPGB:",self.alivetime)
		if(self.state==0 and self.alivetime>=1.9)then
			self.state=self.state+1
			self.drawable:SetAnimationByNumber(158)	
		elseif(self.state==1)then		
			if(self.alivetime>END_TIME)then
				self.state=self.state+1
				self.drawable:SetAnimationByNumber(159)
			end
		elseif(self.state==2 and self.alivetime>END_TIME+1.9)then
			self.state=self.state+1
			self:Die()
		end
	end
end


do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_UUNAT_Drawable_PiercingGaze_Beam=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_UUNAT_Drawable_PiercingGaze_Beam
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="spells/8fx_shrineraid_uunat_piercinggaze_beam.m2"	
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.5/self.scale3D	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.5
		--self.zsortoffset3D=0.5	--measured in yards.  TODO: move to modelinfo
		self.zsortoffset3D=0
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
	
	function class:Get3DPositionCoords()
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		--print("Flames angle:",self.owner.currentfacing)
		-- local radius=0--450/2
		-- --local newx=self.x+math.cos(self.owner.currentfacing)*radius
		-- --local newy=self.y+radius-math.sin(self.owner.currentfacing)*radius
		-- local newx=self.x+radius+math.cos(self.owner.currentfacing_3D)*radius
		-- local newy=self.y+math.sin(self.owner.currentfacing_3D)*radius
		-- local newz=self.z+yard*0.25
		-- --local newx=0
		-- --local newy=0
		-- --local newz=self.z+yard*0.25
		
		local newx=self.x-yard*18
		local newy=self.y
		local newz=self.z

		return newx,newy,newz
	end	
	
	function class:GetFacingRadians()
		return self.owner.currentfacing+math.pi
	end
	
end

do
	local super=TRAININGGROUNDS_Sprite
	TRAININGGROUNDS_UUNAT_Sprite_PiercingGaze=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_UUNAT_Sprite_PiercingGaze
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		-- must set groupdancemodule after calling setup
		self.groupdancemodule=nil
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite.new()		
		self.drawable:Setup(self,self.environment)
		self.drawable.ystretch=false
		self.drawable.width=100
		self.drawable.height=100	
		self.drawable.frame.texture:Show()
		self.drawable.frame.texture:SetTexture("interface\\icons\\spell_fire_twilightflamestrike.blp")
		self.drawable.frame.fontstring:Show()
		self.drawable.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",20,"OUTLINE")
		self.drawable.frame.fontstring:SetText("")
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraph
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		local text=""
		local stacktext=""
		local timetext=""
		if(self.groupdancemodule and self.groupdancemodule.player)then
			local gdm=self.groupdancemodule
			local player=gdm.player
			if(gdm.piercestacks<=0)then
				self.visible=false
			else
				self.visible=true
				if(gdm.piercestacks==1)then
					stacktext="1 stack"
				else
					stacktext=tostring(gdm.piercestacks).." stacks"
				end
				timetext=string.format("%02d",math.floor(gdm.pierceduration))
				text=stacktext.."\r".."0:"..timetext
			end
		end
		self.drawable.frame.fontstring:SetText(text)
	end
end