
TRAININGGROUNDS_RaidRole = {}
TRAININGGROUNDS_RaidRole.__index = TRAININGGROUNDS_RaidRole

function TRAININGGROUNDS_RaidRole.new()
	local self=setmetatable({}, TRAININGGROUNDS_RaidRole)	
	return self
end

function TRAININGGROUNDS_RaidRole:Setup(frequency)
	self:SetCustomInfo()
	-- Frequency is expected to be set by ClassSpecialization:AddRaidRole.
	-- A role with a frequency of nil is passive.
	-- A role with a specified frequency has a cooldown (e.g. interrupts)
		-- and may require more than one player to fill a given scenario's role.
	self.frequency=frequency
	-- TODO: "exclusive" flag which prevents duplicate roles (such as the old-style disc priest)
		-- (we're not sure implementing this is actually a good idea)
end

function TRAININGGROUNDS_RaidRole:SetCustomInfo()
	--override
end


--static function
function TRAININGGROUNDS_RaidRole_MeleeDistanceFunction(target,origincombat,mindistance)
	--TODO: NYI
	--if (origincombat.owner.environment:GetCombatDistance(origincombat,self.owner)>=mindistance)then
		return true
	--else
		--return false
	--end
end

function TRAININGGROUNDS_RaidRole:Setup(ownercombat)
	self.owner=ownercombat
end

function TRAININGGROUNDS_RaidRole:IsAtRange(origincombat,mindistance)
	--override
	return true
end

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------

--TODO: we're not using this for anything at the moment
-- TODO: even if we were using this, it's no longer compatible with the
	-- one-class-can-have-multiple-roles system
function TRAININGGROUNDS_RaidRole:IsAtRange(origincombat,mindistance)
	return true
end

--TODO: move to separate files, maybe

TRAININGGROUNDS_RaidRole_DPS = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
TRAININGGROUNDS_RaidRole_RDPS = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole_DPS)
TRAININGGROUNDS_RaidRole_Healer = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
TRAININGGROUNDS_RaidRole_RHealer = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole_Healer)
TRAININGGROUNDS_RaidRole_ShieldHealer = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole_RHealer)
TRAININGGROUNDS_RaidRole_MDPS = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole_DPS)
TRAININGGROUNDS_RaidRole_MHealer = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole_Healer)
TRAININGGROUNDS_RaidRole_Tank = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
TRAININGGROUNDS_RaidRole_MTank = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole_Tank)

-- TRAININGGROUNDS_RaidRole_DPS = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_Healer = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_Tank = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_Melee = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_AbsorbShields = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_IgnoreKnockback = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_RaidHealingCooldown = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_RaidHasteCooldown = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_RaidMovementCooldown = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)
-- TRAININGGROUNDS_RaidRole_BattleRez = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_RaidRole)

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------